#include <mpp/mpp.h>
#include <mpp/manager.h>

namespace mpp{
  // task priorities
  int mpp::priority_hour=8;
  int mpp::priority_day=14;
  int mpp::priority_week=19;
  int  mpp::priority_value=mpp::priority_hour;
  bool mpp::priority_changed=false;
  double sleep_time=0.5;
  // new calc functions
  void (*mpp::Calc_func)(void);		// new thread    
  void (*mpp::Calc_func_)(void);	// same thread
  void (*mpp::Calc_func_3)(void);	// same thread by timer


  bool                            mpp::ask_stop=false;    // namespace member
  bool                            mpp::calc=false;        // namespace member
  volatile bool	                mpp::suspend_flag=false;        // namespace member
  double							mpp::update_time=0.05;	
  mpp::Group *                    mpp::Group::current_=0; // static member
  bool 							mpp::visible_v=true;
  const char *					mpp::mppg_info=\
    "MPPG 2.6.0\n\
MPPG (Modeling Physical Phenomena Graphical User Interface)\n\
is a cross-platform C++ GUI library for UNIX/Linux (X11),Microsoft Windows.\n\
MPPG provides GUI for numeric calculations.\n\
home: ftp://ancient.hydro.nsc.ru/local/mppg,  user=ftp\n\
EMail:  pru_A_hydro.nsc.ru\n\
17.07.04";

  Widget::Widget(){
    if (mpp::Group::current_) {
      mpp_parent_=mpp::Group::current_;
      mpp::Group::current_->add(this);
    }
    else {
      mpp_parent_=0;
      mpp::group_list().push_back(this);
    }
    need_update=true;
  }

  Group::Group(){
    current_=this;
  }

  void Group::add(mpp::Widget *w){
    widget_list.push_back(w);
  }

  void mpp::Group::mpp_end(){
    if (mpp_parent_) current_=mpp_parent_;
    else current_=0;
  }

  void mpp::Group::mpp_begin(){
    //current_old=current_;
    current_=this;
  }


  void mpp::Group::update(){
    Widget::update();
    for (std::list<mpp::Widget*>::iterator p=widget_list.begin(); p!=widget_list.end(); ++p) {
      //if ((*p)->need_update) {			
      (*p)->update();
      //}
    }
  }

  void mpp::Group::ask_update(){
    Widget::ask_update();
    for (std::list<mpp::Widget*>::const_iterator p=widget_list.begin(); p!=widget_list.end(); ++p) {
      (*p)->ask_update();
    }
  }

  void mpp::Group::set_value(){
    for (std::list<mpp::Widget*>::const_iterator p=widget_list.begin(); p!=widget_list.end(); ++p) {
      (*p)->set_value();
    }
  }

  mpp::Window::Window(){
    if (! mpp_parent_) mpp::window_list().push_back(this);	
  }


  void update(){
    for (std::list<mpp::Widget*>::iterator p=mpp::group_list().begin(); p!=mpp::group_list().end(); ++p) {
      (*p)->update();
    }
  }

  void ask_update(){
    for (std::list<mpp::Widget*>::iterator p=mpp::group_list().begin(); p!=mpp::group_list().end(); ++p) {
      (*p)->ask_update();
    }
  }

  void set_value(){
    for (std::list<mpp::Widget*>::const_iterator p=mpp::group_list().begin(); p!=mpp::group_list().end(); ++p) {
      (*p)->set_value();
    }
  }

  void set_work(void (*f)(void)){
    mpp::Calc_func=f;
  }
  void set_work2(void (*f)(void)){
    mpp::Calc_func_=f;
  }
  void set_work3(void (*f)(void), double sleep_time){       // set void f(void) to exequte  
    mpp::sleep_time=sleep_time;
    mpp::Calc_func_3=f;                  // in the same thread by timer
  }

  std::list<mpp::Window*>& window_list(){		// for mpp manager
    static std::list<mpp::Window*> w;
    return w;
  }

  std::list<mpp::Widget*>& group_list(){			// for update, ...
    static std::list<mpp::Widget*> w;
    return w;
  }

};
